/****************************************************************************
 *
 *  *********************************************************************
 *  *   Copyright (C) 2004-2005 KONICA MINOLTA MEDICAL&GAPHIC, INC.     *
 *  *   All rights reserved.                                            *
 *  *********************************************************************
 *
 *Υƥ̾Ρ
 *  DRYPRO MODEL 793 PEBǥХɥ饤
 *
 *Υ⥸塼̾Ρ
 *  PrnDev.h
 *
 *Υȡ
 *  ǥХɥ饤ФΥإåե
 *
 ****************************************************************************/

#ifndef __PRN_DEV_H__
#define __PRN_DEV_H__

#ifdef __cplusplus
extern "C" {
#endif


/****************************************************************************
 *
 *
 *  
 *
 *
 ****************************************************************************/

/*==========================================================================*
 *
 *  ǥХ
 *
 *==========================================================================*/
#define PRN_DEV_PATH    "/dev/PrnDev"  // ǥХѥ̾
#define PRN_DEV_NAME    "PrnDev"       // ǥХ̾


/****************************************************************************
 *
 *
 *  I/O
 *
 *
 ****************************************************************************/

/*==========================================================================*
 *
 *  I/Oѥ᡼
 *
 *==========================================================================*/
/*--------------------------------------------------------------------------*
 *  ǥХ
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iow_info {
    unsigned long ulDevBuffSize;        // [I-] ǥХХåե
} EIOPSETINFO;

/*--------------------------------------------------------------------------*
 *  ǥХ
 *--------------------------------------------------------------------------*/
typedef struct _eiop_ior_info {
    unsigned long ulDevBuffSize;        // [-O] ǥХХåե
    unsigned long ulDevDataLen;         // [-O] ǥХǡĹ
    unsigned long ulPebRamType;         // [-O] PEB̥
        #define EIOVRAM512MB    (0)     //      512MB
        #define EIOVRAM1GB      (1)     //      1GB
    unsigned long ulPebFontAddr;        // [-O] եȳǼɥ쥹
    unsigned long ulPebImgInAddr[2];    // [-O] ϲǼɥ쥹(0:512MB,1:1GB)
    unsigned long ulPebImgTmpAddr[2];   // [-O] ֲǼɥ쥹(0:512MB,1:1GB)
    unsigned long ulPebImgOutAddr[2];   // [-O] ϲǼɥ쥹(0:512MB,1:1GB)
    unsigned long ulPebRegSize;         // [-O] 쥸ΰ襵
    unsigned long ulPebRegAddr;         // [-O] 쥸ΰ襢ɥ쥹
    unsigned long ulDevDrvVer;          // [-O] ɥ饤ХСֹ
    unsigned long ulDevDrvRev;          // [-O] ɥ饤Хӥֹ
    unsigned long ulPebFpgaVer;         // [-O] FPGAǡСֹ
    unsigned long ulPebFpgaRev;         // [-O] FPGAǡӥֹ
    unsigned long ulPebBoardRev;        // [-O] PEBĥӥֹ
    unsigned long ulPebRomSize;         // [-O] FPGAե졼ΰ襵
    unsigned long ulPebRomAddr[2];      // [-O] FPGAե졼ΰ襢ɥ쥹
} EIOPGETINFO;

/*--------------------------------------------------------------------------*
 *  ǥХּ
 *--------------------------------------------------------------------------*/
typedef struct _eiop_ior_stat {
    unsigned long ulDevErrorNo;         // [-O] ǥХ顼ֹ
        #define EIOVDEVNOERR    (0)     //      顼ʤ
        #define EIOVDEVREGERR   (1)     //      ɥ饤Ͽ
        #define EIOVDEVNOENT    (2)     //      ǥХ̤
        #define EIOVDEVIOMERR   (3)     //      I/Oޥåԥ󥰼
        #define EIOVDEVPHYERR   (4)     //      ʪ
        #define EIOVDEVIRQERR   (5)     //      IRQϿ
        #define EIOVDEVMEMERR   (6)     //      ͥ
    unsigned long ulDevOpeStat;         // [-O] ǥХ
        #define EIOVDEVUNAVAIL  (0)     //      Բ
        #define EIOVDEVIDLE     (1)     //      Ԥ
        #define EIOVDEVDMA      (2)     //      DMA
        #define EIOVDEVBRDR     (3)     //      ܡ
        #define EIOVDEVIMG      (4)     //      
        #define EIOVDEVCHR      (5)     //      ʸ
        #define EIOVDEVPTC      (6)     //      ǻ٥ѥå
        #define EIOVDEVPRNT     (7)     //      ץȽ
    unsigned long ulPebOpeStat;         // [-O] PEB
        #define EIOVPEBNONE     (0)     //      ֤ʤ
        #define EIOVPEBIDLE     (1)     //      ɥ
        #define EIOVPEBPDMA     (2)     //      PCI-DMAž
        #define EIOVPEBPDMAIMG  (3)     //      PCI-DMAǡž
        #define EIOVPEBBRDR     (4)     //      ܡ
        #define EIOVPEBIMG      (5)     //      
        #define EIOVPEBHIMG     (6)     //      ʼ
        #define EIOVPEBVIMG     (7)     //      
        #define EIOVPEBCHR      (8)     //      ʸ
        #define EIOVPEBPTC      (9)     //      ǻ٥ѥå
        #define EIOVPEBVSNC     (10)    //      VSYNCԤ
        #define EIOVPEBPRNT     (11)    //      ץȽ
    unsigned long ulPebPrnStat;         // [-O] ץȽ
        #define EIOBPRNHSNCERR  (0x1)   //      HSYNCॢȥ顼
        #define EIOBPRNDETPERR  (0x2)   //      ̸Υ顼
        #define EIOBPRNPRTYERR  (0x4)   //      ѥƥ顼
    unsigned long ulPDMACtl;            // [-O] PCI-DMA쥸
    unsigned long ulUnitCtl;            // [-O] ˥å쥸
    unsigned long ulPrnCtl;             // [-O] ץ쥸
    unsigned long ulPrtState;           // [-O] ץȥơ쥸
    unsigned long ulIntReq;             // [-O] INTAװ쥸
    unsigned long ulIntMsk;             // [-O] INTAޥ쥸
} EIOPGETSTAT;

/*--------------------------------------------------------------------------*
 *  PEB쥸꡿
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iowr_reg {
    unsigned long ulPebRegAddr;         // [I-] PEB쥸륢ɥ쥹
    unsigned long ulPebRegData;         // [IO] 쥸
} EIOPSETREG, EIOPGETREG;

/*--------------------------------------------------------------------------*
 *  PEB꡿
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iowr_mem {
    unsigned long ulPebMemAddr;         // [I-] PEB륢ɥ쥹
    unsigned long ulPebMemData;         // [IO] 
} EIOPSETMEM, EIOPGETMEM;

/*--------------------------------------------------------------------------*
 *  FLASH
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iowr_flash {
    unsigned long ulPebRomAddr;         // [I-] PEB륢ɥ쥹
    unsigned long ulSetWatchTime;       // [I-] ǧԤ(ms)
    unsigned long ulSetResult;          // [-O] 
        #define EIOVFLWRITEOK   (0)     //      ｪλ
        #define EIOVFLWRITETO   (1)     //      񤭹ߥॢ
        #define EIOVFLWRITENG   (2)     //      񤭹ߥ顼
} EIOPSETFLASH;

/*--------------------------------------------------------------------------*
 *  FLASH
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iow_flash {
    unsigned long ulPebRomAddr;         // [I-] PEB륢ɥ쥹
    unsigned long ulGetSize;            // [I-] FLASH
} EIOPGETFLASH;

/*--------------------------------------------------------------------------*
 *  PEBƥ
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iowr_test {
    unsigned long ulTestType;           // [I-] ƥȥ
        #define EIOVTESTDATABUS (0)     //      ǡХƥ
        #define EIOVTESTADDRBUS (1)     //      ɥ쥹Хƥ
        #define EIOVTESTMEMCOMP (2)     //      ꥳڥƥ
    unsigned long ulTestResult;         // [-O] ƥȷ
        #define EIOVTESTOK      (0)     //      ｪλ
        #define EIOVTESTNG      (1)     //      ۾ｪλ
} EIOPPEBTEST;

/*--------------------------------------------------------------------------*
 *  Ϫ
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iow_exp {
    unsigned long ulExpMode;            // [I-] Ϫ⡼
        #define EIOVEXPNORMAL   (0)     //      ̾⡼
        #define EIOVEXPCHECK    (1)     //      å⡼
        #define EIOVEXPMAINTE   (2)     //      ƥʥ󥹥⡼
    unsigned long ulChkMode;            // [I-] å⡼
        #define EIOVCHKPSTART   (0)     //      ݥꥴå
        #define EIOVCHKLSTART   (1)     //      졼å
        #define EIOVCHKHSTART   (2)     //      HSYNCå
        #define EIOVCHKEND      (3)     //      åλ
    unsigned long ulMntMode;            // [I-] ƥʥ󥹥⡼
        #define EIOVMNTSTART    (0)     //      ƥʥ󥹳
        #define EIOVMNTCHECK    (1)     //      ƥʥ󥹳ǧ
        #define EIOVMNTEND      (2)     //      ƥʥ󥹽λ
    unsigned long ulLaserMode;          // [I-] 졼⡼
        #define EIOVLASEROFF    (0)     //      졼OFF
        #define EIOVLASERON     (1)     //      졼ON
    unsigned long ulPolygonMode;        // [I-] ݥꥴ⡼
        #define EIOVPOLYGONOFF  (0)     //      ݥꥴOFF
        #define EIOVPOLYGONON   (1)     //      ݥꥴON
    unsigned long ulPolygonSize;        // [I-] ݥꥴž
        #define EIOVSIZE4375    (0)     //      ǥ43.75
        #define EIOVSIZE2500    (1)     //      ǥ25
    unsigned long ulPolygonTime;        // [I-] ݥꥴž
    unsigned long ulBriHsync;           // [I-] HSYNCи
    unsigned long ulTopHsync;           // [I-] HSYNCгϰ
    unsigned long ulEndHsync;           // [I-] HSYNCнλ
} EIOPSETEXP;

/*--------------------------------------------------------------------------*
 *  Ϫּ
 *--------------------------------------------------------------------------*/
typedef struct _eiop_ior_exp {
    unsigned long ulLaserMode;          // [-O] 졼⡼
    unsigned long ulPolygonMode;        // [-O] ݥꥴ⡼
    unsigned long ulPolygonSize;        // [-O] ݥꥴž
    unsigned long ulPolygonTime;        // [-O] ݥꥴž
    unsigned long ulExpRead;            // [-O] Ϫ
        #define EIOBEORPEVR     (0x400) //      EORPEVR (0=LO/1=HI)
        #define EIOBEORLDON     (0x200) //      EORLDON (0=LO/1=HI)
        #define EIOBEORPON      (0x100) //      EORPON  (0=LO/1=HI)
        #define EIOBEIRPRTE     (0x080) //      EIRPRTE (0=LO/1=HI)
        #define EIOBEIRDETP     (0x040) //      EIRDETP (0=LO/1=HI)
        #define EIOBEIRLDCU     (0x020) //      EIRLDCU (0=LO/1=HI)
        #define EIOBEIRLDBR     (0x010) //      EIRLDBR (0=LO/1=HI)
        #define EIOBEIRPLCK     (0x008) //      EIRPLCK (0=LO/1=HI)
        #define EIOBEIRTHRM     (0x004) //      EIRTHRM (0=LO/1=HI)
        #define EIOBEIRHSNC     (0x002) //      EIRHSNC (0=LO/1=HI)
        #define EIOBEIRVSNC     (0x001) //      EIRVSNC (0=LO/1=HI)
    unsigned long ulExpLatch;           // [-O] Ϫå
        #define EIOBEILPRTE     (0x8)   //      EIRPRTE å
        #define EIOBEILDETP     (0x4)   //      EIRDETP å
        #define EIOBEILHSNC     (0x2)   //      EIRHSNC å
        #define EIOBEILVSNC     (0x1)   //      EIRVSNC å
    unsigned long ulPolygonStat;        // [-O] ݥꥴ
        #define EIOVPSOFF       (0)     //      ݥꥴOFF
        #define EIOVPSBOOT      (1)     //      ݥꥴư
        #define EIOVPSREBOOT    (2)     //      ݥꥴƵư
        #define EIOVPSLOCK      (3)     //      ݥꥴLOCK
    unsigned long ulPebErrCode;         // [-O] PEB顼
        #define EIOVPENONE      (0)     //      顼ʤ
        #define EIOVPEHSNC      (1)     //      HSYNCॢ
        #define EIOVPEBOOT      (2)     //      ݥꥴư顼
} EIOPGETEXP;

/*--------------------------------------------------------------------------*
 *  DMA
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iow_dma {
    unsigned long ulDmaType;            // [I-] DMA
        #define EIOVDMANORMAL   (0)     //      ̾DMA
        #define EIOVDMAIMAGE    (1)     //      DMA
    unsigned long ulDmaMode;            // [I-] DMA⡼
        #define EIOVDMANEW      (0)     //      DMA
        #define EIOVDMANEXT     (1)     //      ³DMA
    unsigned long ulDmaDir;             // [I-] DMAž
        #define EIOVDMAWRITE    (0)     //      M/BPEB
        #define EIOVDMAREAD     (1)     //      M/BPEB
    unsigned long ulDevBuffAddr;        // [I-] ǥХХåեեåȥɥ쥹
    unsigned long ulPebMemAddr;         // [I-] PEB륢ɥ쥹
    unsigned long ulDmaSize;            // [I-] DMAž
    unsigned long ulImgILPix;           // [I-] ϣ饤ǿ
    unsigned long ulImgIHPix;           // [I-] ϥե졼ǿ
} EIOPOPEDMA;

/*--------------------------------------------------------------------------*
 *  ܡ
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iow_brdr {
    unsigned long ulBrdrDens;           // [I-] ܡǻ
    unsigned long ulBrdrTopAddr;        // [I-] ܡϥɥ쥹
    unsigned long ulBrdrEndAddr;        // [I-] ܡλɥ쥹
    unsigned long ulImgOutAddr;         // [I-] ϲΰ襢ɥ쥹
} EIOPOPEBRDR;

/*--------------------------------------------------------------------------*
 *  
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iow_img {
    unsigned long ulImgMode;            // [I-] ⡼
        #define EIOVIMGOFF      (0)     //      OFF
        #define EIOVIMGON       (1)     //      ON
    unsigned long ulTrmMode;            // [I-] ȥ⡼
        #define EIOVTRMOFF      (0)     //      ȥOFF
        #define EIOVTRMON       (1)     //      ȥON
    unsigned long ulImgInAddr;          // [I-] ϲΰ襢ɥ쥹
    unsigned long ulImgTmpAddr;         // [I-] ֲǼɥ쥹
    unsigned long ulImgOutAddr;         // [I-] ϲΰ襢ɥ쥹
    unsigned long ulImgILPix;           // [I-] ϣ饤ǿ
    unsigned long ulImgOLPix;           // [I-] ϣ饤ǿ
    unsigned long ulImgIFAddr;          // [I-] ϥե졼ॢɥ쥹
    unsigned long ulImgOFAddr;          // [I-] ϥե졼ॢɥ쥹
    unsigned long ulImgIHPix;           // [I-] ϥե졼ǿ
    unsigned long ulImgIVPix;           // [I-] ϥե졼ǿ
    unsigned long ulImgOHPix;           // [I-] ϥե졼ǿ
    unsigned long ulImgOVPix;           // [I-] ϥե졼ǿ
    unsigned long ulImgHRatio;          // [I-] Ψ
    unsigned long ulImgVRatio;          // [I-] Ψ
    unsigned long ulImgLayout;          // [I-] 쥤
    unsigned long ulTrmPix;             // [I-] ȥ
    unsigned long ulTrmDens;            // [I-] ȥǻ
    unsigned long ulHokanLUT[4][256];   // [I-] ַ(w0-w3)
} EIOPOPEIMG;

/*--------------------------------------------------------------------------*
 *  ʸ
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iow_chr {
    unsigned long ulFontAddr;           // [I-] եȳϥɥ쥹
    unsigned long ulFontByte;           // [I-] եȥХȿ
    unsigned long ulFontHPix;           // [I-] եȽĲǿ
    unsigned long ulFontWPix;           // [I-] եȲǿ
    unsigned long ulCharDens;           // [I-] ʸǻ٤
    unsigned long ulCharAddr;           // [I-] ʸ󳫻ϥɥ쥹
    unsigned long ulCharByte;           // [I-] ʸ
    unsigned long ulCharLayout;         // [I-] ʸ쥤
    unsigned long ulCharCode[256];      // [I-] ʸ󥳡
} EIOPOPECHR;

/*--------------------------------------------------------------------------*
 *  ǻ٥ѥå
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iow_ptc {
    unsigned long ulPtcAddr;            // [I-] ѥåϥɥ쥹
    unsigned long ulPtcHPix;            // [I-] ѥåǿ
    unsigned long ulPtcVPix;            // [I-] ѥåǿ
    unsigned long ulPtcDens;            // [I-] ѥåǻ
} EIOPOPEPTC;

/*--------------------------------------------------------------------------*
 *  ץȽ
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iow_prnt {
    unsigned long ulBriHsync;           // [I-] HSYNCи
    unsigned long ulTopHsync;           // [I-] HSYNCгϰ
    unsigned long ulEndHsync;           // [I-] HSYNCнλ
    unsigned long ulTopHPix;            // [I-] ǡϳϰ
    unsigned long ulEndHPix;            // [I-] ǡϽλ
    unsigned long ulLineHPix;           // [I-] ǡϲǿ
    unsigned long ulTopVPix;            // [I-] ǡϳϰ
    unsigned long ulEndVPix;            // [I-] ǡϽλ
    unsigned long ulPrnAddr;            // [I-] ץȳϥɥ쥹
    unsigned long ulPrnLOPix;           // [I-] ץȣ饤ǿ
    unsigned long ulMuraMode;           // [I-] ⡼
        #define EIOVLUTDEFAULT  (0)     //      ǥեȥ⡼
        #define EIOVLUTSWITCH   (1)     //      إ⡼
    unsigned long ulMuraSwitch;         // [I-] عԿ
    unsigned long ulTopMuraPix;         // [I-] ϲǰ
    unsigned long ulEndMuraPix;         // [I-] λǰ
    unsigned long ulTopKotanPix;        // [I-] üϲǰ
    unsigned long ulTopUtanPix;         // [I-] üϲǰ
    unsigned long ulKoryoLUT[256];      // [I-] ǻ١ѴLUT
    unsigned long ulMuraLUT[15][6*64];  // [I-] (1-15)
    unsigned long ulSentanLUT[64];      // [I-] üLUT
    unsigned long ulKotanLUT[32];       // [I-] üLUT
    unsigned long ulSayutanLUT[16];     // [I-] üLUT
    unsigned long ulFFReqData[6];       // [I-] ȿĴǡ(#0-#5)
    unsigned long ulFLineData[1];       // [I-] 쥸ȥ󥵴ֵΥ#0
    unsigned long ulFFMod;              // [I-] ȿĴ
        #define EIOVFFMODOFF    (0)     //      ĴOFF
        #define EIOVFFMODON     (1)     //      ĴON
    unsigned long ulFDelayRatio;        // [I-] Ĵǥ쥤ʿ
    unsigned long ulFCut;               // [I-] Ĵǥ쥤
    unsigned long ulFSel1stAdj;         // [I-] ȿ쥯Ƚ̥㥹
    unsigned long ulFSelAdj;            // [I-] ȿ쥯ٱ䥢㥹
    unsigned long ulLSStart;            // [I-] LSYNCϥߥ
    unsigned long ulLSWidth;            // [I-] LSYNC
} EIOPOPEPRNT;

/*--------------------------------------------------------------------------*
 *  PEBꥻå
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iow_reset {
    unsigned long ulResetWatchTime;     // [I-] ꥻåȳǧԤ(ms)
} EIOPPEBRESET;

/*--------------------------------------------------------------------------*
 *  FLASHõ
 *--------------------------------------------------------------------------*/
typedef struct _eiop_iowr_erase {
    unsigned long ulEraseWatchTime;     // [I-] õǧԤ(ms)
    unsigned long ulEraseResult;        // [-O] õ̡FLASH򻲾ȡ
} EIOPDELFLASH;

/*==========================================================================*
 *
 *  I/O楳ޥ
 *
 *==========================================================================*/
#define EIOCMAGIC       (250)       // ޥåʥС

#define EIOCSETINFO     _IOW(  EIOCMAGIC, 1,  struct _eiop_iow_info   ) // ǥХ
#define EIOCGETINFO     _IOR(  EIOCMAGIC, 2,  struct _eiop_ior_info   ) // ǥХ
#define EIOCGETSTAT     _IOR(  EIOCMAGIC, 3,  struct _eiop_ior_stat   ) // ǥХּ
#define EIOCSETREG      _IOW(  EIOCMAGIC, 4,  struct _eiop_iowr_reg   ) // PEB쥸
#define EIOCGETREG      _IOWR( EIOCMAGIC, 5,  struct _eiop_iowr_reg   ) // PEB쥸
#define EIOCSETMEM      _IOW(  EIOCMAGIC, 6,  struct _eiop_iowr_mem   ) // PEB
#define EIOCGETMEM      _IOWR( EIOCMAGIC, 7,  struct _eiop_iowr_mem   ) // PEB
#define EIOCSETFLASH    _IOWR( EIOCMAGIC, 8,  struct _eiop_iowr_flash ) // FLASH
#define EIOCGETFLASH    _IOW(  EIOCMAGIC, 9,  struct _eiop_iow_flash  ) // FLASH
#define EIOCPEBTEST     _IOWR( EIOCMAGIC, 10, struct _eiop_iowr_test  ) // PEBƥ
#define EIOCSETEXP      _IOW(  EIOCMAGIC, 11, struct _eiop_iow_exp    ) // Ϫ
#define EIOCGETEXP      _IOR(  EIOCMAGIC, 12, struct _eiop_ior_exp    ) // Ϫּ
#define EIOCOPEDMA      _IOW(  EIOCMAGIC, 13, struct _eiop_iow_dma    ) // DMA
#define EIOCOPEBRDR     _IOW(  EIOCMAGIC, 14, struct _eiop_iow_brdr   ) // ܡ
#define EIOCOPEIMG      _IOW(  EIOCMAGIC, 15, struct _eiop_iow_img    ) // 
#define EIOCOPECHR      _IOW(  EIOCMAGIC, 16, struct _eiop_iow_chr    ) // ʸ
#define EIOCOPEPTC      _IOW(  EIOCMAGIC, 17, struct _eiop_iow_ptc    ) // ǻ٥ѥå
#define EIOCOPEPRNT     _IOW(  EIOCMAGIC, 18, struct _eiop_iow_prnt   ) // ץȽ
#define EIOCPEBRESET    _IOW(  EIOCMAGIC, 19, struct _eiop_iow_reset  ) // PEBꥻå
#define EIOCDELFLASH    _IOWR( EIOCMAGIC, 20, struct _eiop_iowr_erase ) // FLASHõ

#define EIOCMAXNO       (20)        // I/O楳ޥɿ


#ifdef __cplusplus
}
#endif

#endif /* __PRN_DEV_H__ */
